package org.ow2.util.deployment.annotations.analyzer;

import java.util.ArrayList;
import java.util.List;

import org.ow2.easybeans.asm.AnnotationVisitor;
import org.ow2.easybeans.asm.commons.EmptyVisitor;
import org.ow2.util.deployment.annotations.analyzer.configurator.CommonConfigurator;
import org.ow2.util.deployment.metadata.structures.JAnnotation;

/**
 * super class of all scanner.
 * @author Gael Lalire
 * @param <T> the class of configurator
 */
public class ScanCommonVisitor<T extends CommonConfigurator> extends EmptyVisitor {

    /**
     * configurators.
     */
    private List<T> commonConfigurators;

    /**
     * @return configurators
     */
    protected List<T> getCommonConfigurators() {
        return commonConfigurators;
    }

    /**
     * Set configurators.
     * @param commonConfigurators configurators
     */
    protected void setCommonConfigurators(final List<T> commonConfigurators) {
        this.commonConfigurators = commonConfigurators;
    }

    /**
     * @param name annotation name
     * @param visible annotation visibility
     * @return a visitor
     */
    @Override
    public AnnotationVisitor visitAnnotation(final String name, final boolean visible) {
        JAnnotation jAnnotation = new JAnnotation(name, visible);
        List<AnnotationVisitor> result = new ArrayList<AnnotationVisitor>();

        for(CommonConfigurator commonConfigurator : commonConfigurators) {
            AnnotationVisitor annotationVisitor = commonConfigurator.getAnnotationVisitor(jAnnotation);
            result.add(annotationVisitor);
        }
        return new ScanAnnotationVisitor(result);
    }

}
