/**
 * EasyBeans
 * Copyright (C) 2006 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: ScanFieldVisitor.java 2234 2008-01-17 16:43:23Z gaellalire $
 * --------------------------------------------------------------------------
 */

package org.ow2.util.deployment.annotations.analyzer;

import java.util.List;

import org.ow2.easybeans.asm.FieldVisitor;
import org.ow2.util.deployment.annotations.analyzer.configurator.FieldConfigurator;

/**
 * ScanFieldVisitor.
 * @author Gael Lalire
 */
public final class ScanFieldVisitor extends ScanCommonVisitor<FieldConfigurator> implements FieldVisitor {

    /**
     * Construtor.
     * @param fieldConfigurators configurators
     */
    public ScanFieldVisitor(final List<FieldConfigurator> fieldConfigurators) {
        setCommonConfigurators(fieldConfigurators);
    }

    /**
     * call configurationComplete on each configurator.
     */
    @Override
    public void visitEnd() {
        for(FieldConfigurator fieldConfigurator : getCommonConfigurators()) {
            fieldConfigurator.configurationComplete();
        }
    }

}
